unit U_Key;

interface
type TKeyVerlauf= record
                  Schuss:boolean;
                  HyperSpace:boolean;
                  Rechts:boolean;
                  Links:boolean;
                  Gas:boolean;
                  obj:integer;
                  obj_schritte:integer;
                  SchussNr:integer;
                  xx,yy:integer;
                  winkel:integer;
                  end;
type TKey = class(TObject)
  private
    FHyperSpace:boolean;
  protected
  public
    keinSchuss:boolean;
    Schuss:boolean;
    Rechts:boolean;
    Links:boolean;
    Gas:boolean;
    obj:integer;
    obj_schritte:integer;
    gesendet:boolean;
    max:integer;
    verlauf:array[0..6000]of TKeyVerlauf;

    constructor Create;
    destructor Destroy; override;
    procedure Idle;
    procedure senden;
    procedure HyperSpace;

    procedure DatenBegin;
    procedure DatenEnd;

  end;

const KEY_SPACE=$01;
      KEY_schuss=$02;
      KEY_gas=$04;
      KEY_rechts=$08;
      KEY_links=$10;
      KEY_START=$20;


implementation
Uses Tools,U_Spiel,U_Asteroid_Manager,U_Asteroid,U_Mame,U_Schiff,U_Schuss_Manager,U_UfoSchuss_Manager,U_UfoSchuss,unit1,
StrUtils, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,  ExtCtrls,Sockets,Konstanten,SyncObjs;

constructor TKey.Create;
var i:integer;
begin
  inherited Create;
  max:=256;
  for i:=0 to max do begin
      Verlauf[i].Schuss:=false;
      Verlauf[i].HyperSpace:=false;
      Verlauf[i].Rechts:=false;
      Verlauf[i].Links:=false;
      Verlauf[i].Gas:=false;
      Verlauf[i].xx:=0;
      Verlauf[i].yy:=0;
      Verlauf[i].winkel:=0;
      Verlauf[i].obj:=-1;
      Verlauf[i].obj_schritte:=-1;
      Verlauf[i].SchussNr:=-1;
  end;


end;

destructor TKey.Destroy;
begin

  inherited Destroy;
end;

procedure TKey.Idle;
var i:integer;
begin
  // Verlauf klein halten
  if (mame.Daten=0)and(spiel.IdleCounter=8)and(
     ((asteroid.anz=0)and(spiel.levelZeit<50)and(max>2000)))
     or (max>5000)
     then begin
          for i:=0 to 256 do verlauf[i]:=verlauf[max-256+i];
          max:=256;
  end;
end;

procedure TKey.HyperSpace;
begin
  FHyperspace:=true;
  senden;  // HyperSpace sofort senden
end;

procedure TKey.senden;
var k:byte;
begin
//  if (spiel.level=1)and(spiel.levelZeit<=2)and(not Verlauf[max-1].Schuss)and(not Verlauf[max-2].Schuss) then key.Schuss:=true; // gib als erstes 1 schuss ab, um das genaue WB zu finden

  if gesendet then exit;
  if FHyperSpace then begin // bei hyperSpace keine anderen Keys senden
     Schuss:=false;
     rechts:=false;
     links:=false;
     gas:=false;
  end;
  if keinSchuss then schuss:=false;

  k:=0;
  if FHyperSpace then k:=k or Key_space;
  if schuss then k:=k or Key_schuss;
  if rechts then k:=k or Key_rechts else
     if links then k:=k or Key_links;
  if gas then k:=k or Key_Gas;

  if (spiel.level=1)and(spiel.levelZeit<=3)and(k=0) then begin k:=Key_links;links:=true;end;  // bewegen um WB genauer zu berechnen

  mame.sendenKey(k);
  gesendet:=true;

  // setze verlauf
  if schuss then begin
     Verlauf[max].SchussNr:=Tools.schuss.xschuss(obj,obj_schritte);
  end;
  Verlauf[max].Schuss:=schuss;
  Verlauf[max].HyperSpace:=FHyperSpace;
  Verlauf[max].Rechts:=rechts;
  Verlauf[max].Links:=links;
  Verlauf[max].Gas:=gas;
  Verlauf[max].xx:=schiff.xx;
  Verlauf[max].yy:=schiff.yy;
  Verlauf[max].winkel:=schiff.winkel;
  Verlauf[max].obj:=obj;
  Verlauf[max].obj_schritte:=obj_schritte;

end;

procedure TKey.DatenBegin;
begin
  // neu
  schuss:=false;
  rechts:=false;
  links:=false;
  gas:=false;
  Fhyperspace:=false;
  gesendet:=false;
  obj:=-1;
  obj_schritte:=-1;
  keinSchuss:=false;

  // neu verlauf
  inc(max);
  Verlauf[max].Schuss:=schuss;
  Verlauf[max].HyperSpace:=FHyperSpace;
  Verlauf[max].Rechts:=rechts;
  Verlauf[max].Links:=links;
  Verlauf[max].Gas:=gas;
  Verlauf[max].xx:=schiff.xx;
  Verlauf[max].yy:=schiff.yy;
  Verlauf[max].winkel:=schiff.winkel;
  Verlauf[max].obj:=obj;
  Verlauf[max].obj_schritte:=obj_schritte;
  Verlauf[max].SchussNr:=-1;

  // Bei Latenz alten Schuss lschen
 if (Latenz=2) then begin
     if Verlauf[max-1].Schuss then begin
         Verlauf[max-1].Schuss:=false;
         if Verlauf[max-1].SchussNr>=0 then tools.schuss.schuss[Verlauf[max-1].SchussNr].active:=false;
         if Verlauf[max-1].obj>=0 then asteroid.Asteroid[Verlauf[max-1].obj].SchussCounter:=-1;
     end;
  end;
  // Bei Latenz Hyperspace wiederholen
  if (Latenz>1)and(Verlauf[max-1].HyperSpace) then begin Hyperspace;exit;end;

  // wenn Hyperspace gedrckt wurde dann sende nix
  if (Verlauf[max-1].HyperSpace)or(Verlauf[max-2].HyperSpace) then begin senden;exit;end;


end;

procedure TKey.DatenEnd;
begin

end;





end.
